#include <string>
#include <vector>

#define MAX_FONT_LEVELS 3
#define MAX_ATTR_LEVELS 2

struct FontDef
{
    std::string fontname;
    std::string fontsize;
    std::string forecolordefs;
    std::string backcolordefs;
    
    const std::string str() const
    {
        return "name(" + fontname + ")"
             + "size(" + fontsize + ")"
             + "fc(" + forecolordefs + ")"
             + "bc(" + backcolordefs + ")";
    }
};
struct Formatting
{
    unsigned B, I, U, S, Bright;
    std::vector<FontDef> FontDefs;
    
    void Reset()
    {
        B=I=U=S=Bright=0;
        FontDefs.clear();
    }
    void Add(unsigned& var, int value)
    {
        long result = var; result += value;
        if(result < 0) result = 0;
        if(result > MAX_ATTR_LEVELS) result = MAX_ATTR_LEVELS;
        var = result;
    }
    void PopFontDef()
    {
        //fprintf(stderr, "Popped FontDef\n");
        if(!FontDefs.empty()) FontDefs.resize(FontDefs.size()-1);
    }
    void PushFontDef(const FontDef& def)
    {
        //fprintf(stderr, "Added FontDef: %s\n", def.str().c_str());
        if(FontDefs.size() > MAX_FONT_LEVELS)
            FontDefs.erase(FontDefs.begin(), FontDefs.begin()+1);
        FontDefs.push_back(def);
    }
    
    const std::string GetUpdatedCodes();
    
    Formatting() { Reset(); }
};
